c     program     :     DEF_CMORPH1.0CRT_CLIM_GLB_step_01_def_20-yr-mean_day-by-day.lnx.f
c     objective   :     to 1998-2017 raw 20-mean daily mean     
c
      parameter  ( kyy_str = 1998, kyy_end = 2017 ) 
c 
      parameter  ( nx = 1440, ny = 480 ) 
c
      character   cdate*8, cfile10*61, cfile50*52      
      dimension   rain (nx,ny),
     #            nn (nx,ny), ss (nx,ny)   
      dimension   nday (12) 
      data        nday / 31, 28, 31, 30, 31, 30, 
     #                   31, 31, 30, 31, 30, 31 / 
c
      write  (6,*)  'started  defining 20-yr mean day by day !!' 
c 
c     1.  to open the output file  
c 
      cfile50 ( 1: 7) = '../rslt' 
      cfile50 ( 8:52) = '/CMORPH1.0CRT_CLIM_DLY_0.25deg_DAY-BY-DAY.lnx' 
      open  (unit=50, 
     #       file=cfile50, 
     #       access='direct',recl=nx*ny*4)   
      write  (6,*)  '     finished openning output file !!' 
c
c     2.  to define raw long-term mean      
c 
      kday = 0 
      do 2999 kmm = 1, 12 
      do 2999 kdd = 1, nday (kmm) 
c 
        kday = kday + 1 
c 
c       2.1  to initialize 
c 
        do 2101  jj = 1, ny  
        do 2101  ii = 1, nx   
          nn (ii,jj) = 0 
          ss (ii,jj) = 0.0 
 2101   continue 
c
c       2.2  to read the daily data for that day over the 20-year period  
c 
        do 2202 kyy = kyy_str, kyy_end 
c 
          kdate = kyy*10000 + kmm*100 + kdd 
          write  (cdate,2951)  kdate 
 2951     format  (i8) 
          cfile10 ( 1:20) = '../../../yyyy/yyyymm'
          cfile10 (21:53) = '/CMORPH_V1.0_ADJ_0.25deg-DLY_00Z_'
          cfile10 (10:13) = cdate (1:4)
          cfile10 (15:20) = cdate (1:6)
          cfile10 (54:61) = cdate (1:8)
          open  (unit=10, 
     #           file=cfile10, 
     #           access='direct', recl=nx*ny*4) 
c 
          read  (10,rec=1)  rain 
c 
          do 2201 jj = 1, ny 
          do 2201 ii = 1, nx    
            if  (rain(ii,jj).ge.0.0)  then
              nn (ii,jj) = nn (ii,jj) + 1 
              ss (ii,jj) = ss (ii,jj) + rain (ii,jj) 
            end  if  
 2201     continue 
          close  (unit=10) 
c 
 2202   continue 
c 
c       2.3.  to calculate raw long-term mean 
c 
        do 2301  jj = 1, ny   
        do 2301  ii = 1, nx   
          if  (nn(ii,jj).gt.0)  then 
            ss (ii,jj) = ss (ii,jj) / nn (ii,jj) 
          else 
            ss (ii,jj) = -999.0 
          end  if  
 2301   continue 
c
c       2.4  to output 
c 
        kout = kday 
        write  (50,rec=kout)  ss 
c 
        write  (6,*)  kday, ss (480,360), nn (480,360) 
c
 2999 continue 
c 
      write  (6,*)  'finished defining 20-yr mean day by day !!' 
c 
c
      stop 
      end
