c     program     :     DEF_CMORPH1.0CRT_CLIM_GLB_step_02_def_BLD_clim_dly_har.lnx.f
c     objective   :     to decompose the raw time series through harmonic analysis   
c                       ch 01 / 10   raw  
c                       ch 02 / 10   mean   
c                       ch 03 / 10   harmonics 01   
c                       ch 04 / 10   harmonics 02  
c                       ch 05 / 10   harmonics 03   
c                       ch 06 / 10   harmonics 04   
c                       ch 07 / 10   harmonics 05   
c                       ch 08 / 10   harmonics 06   
c                       ch 09 / 10   harmonics 07   
c                       ch 10 / 10   harmonics 08   
c
      parameter  ( nx = 1440, ny = 480, nday = 365 )
c
      character   cfile10*52, cfile50*56         
c
      dimension   rain0 (nx,ny,nday), rain1 (nx,10,nday),  
     #            rdata (nday), rout (nday,nday), rxout (nx)  
c
c     1.  to open files
c
      write  (6,*)  'started  performing harmonics analysis !!' 
c
      cfile10 ( 1: 7) = '../rslt'
      cfile10 ( 8:52) = '/CMORPH1.0CRT_CLIM_DLY_0.25deg_DAY-BY-DAY.lnx'
c
c     file 50 : harmonics for raw time series  
c 
      cfile50 ( 1: 7) = '../rslt'
      cfile50 ( 8:37) = '/CMORPH1.0CRT_CLIM_DLY_0.25deg'
      cfile50 (38:56) = '_DAY-BY-DAY_HAR.lnx'
c
      open  (unit=10,
     #       file=cfile10,
     #       access='direct', recl=nx*ny*365*4)
      open  (unit=50,
     #       file=cfile50,
     #       access='direct', recl=nx*4)
      write  (6,*)  '     finished openning files !!' 
c
c     2.  to define  
c
c     2.1  to read in raw 30-yr mean 
c 
      read  (10,rec=1)  rain0 
      write  (6,*)  '     finished reading raw 20-yr mean !!' 
c 
c     2.2  to fill in gaps  
c 
      do 2206 jj = 1, ny 
      do 2206 ii = 1, nx 
c 
        nd = 0 
        do 2201 kday = 1, nday  
          if  (rain0 (ii,jj,kday).ge.0.0)  then 
            nd = nd + 1 
          end  if  
 2201   continue 
        if  (nd.eq.nday)  then 
          go  to  2206  
        else  if  (nd.lt.300)  then 
          do 2202 khh = 1, 24 
            rain0 (ii,jj,kday) = -999.0 
 2202     continue 
        else 
 2203     nmiss = 0 
          do 2205 kday = 1, nday 
            if  (rain0(ii,jj,kday).lt.0.0)  then 
              kd0 = kday - 2 
              kd1 = kday + 2 
              n   = 0 
              s   = 0.0 
              do 2204 kd = kd0, kd1 
                if  (kd.lt.1)  then 
                  km = kd + nday  
                else  if  (kd.ge.1.and.kd.le.nday)  then 
                  km = kd 
                else 
                  km = kd - nday  
                end  if  
                if  (rain0(ii,jj,km).ge.0.0)  then 
                  n = n + 1 
                  s = s + rain0 (ii,jj,km) 
                end  if  
 2204         continue 
              if  (n.gt.0)  then 
                rain0 (ii,jj,kday) = s / n 
              else 
                nmiss = nmiss + 1 
              end  if  
            end  if  
 2205     continue  
          if  (nmiss.gt.0)  then 
            go  to  2203 
          end  if  
        end  if  
 2206 continue 
      write  (6,*)  '     finished filling in gaps !!' 
c
c     2.3  to truncate the raw time series 
c 
      do 2499 jj = 1, ny 
c
        write  (6,*)  '     started  for :', jj 
c 
        do 2305 ii = 1, nx    
c 
          do 2301 kday = 1, nday 
            rain1 (ii,1, kday) = rain0 (ii,jj,kday)
 2301     continue
c 
          if  (rain0(ii,jj,1).lt.0.0)  then 
            do 2302 kday = 1, nday  
            do 2302 kff = 1, 9
              rain1 (ii,kff+1,kday) = -999.0 
 2302       continue
c
          else             
c 
            do 2303 kday = 1, nday      
              rdata (kday) = rain0 (ii,jj,kday) 
 2303       continue 
            ndata = nday       
            call  fourier (ndata,rdata,rout) 
            do 2304 kday = 1, nday     
            do 2304  kff = 1, 9  
              rain1 (ii,kff+1,kday) = rout (kday,kff) 
 2304       continue 
          end  if  
 2305   continue 
c        write  (6,*)  '     finished truncating !!' 
c
c       2.4  to output 
c 
        do 2402 kday = 1, nday 
        do 2402 kff  = 1, 10 
c 
          kout = (kday-1)*10*ny + (kff-1)*ny + jj 
          do 2401 ii = 1, nx 
            rxout (ii) = rain1 (ii,kff,kday) 
 2401     continue 
c  
          write  (50,rec=kout)  rxout 
c 
 2402   continue   
c 
        write  (6,*)  '     finished for :', jj 
 2499 continue 
      write  (6,*)  '     finished output !!' 
c 
      write  (6,*)  'finished performing harmonics analysis !!' 
c 
c 
      stop 
      end  
c
c
      subroutine  fourier (ndata,rdata,rout) 
c
c     #######################################################################
c     #                                                                     #
c     #  program     :                                                      #
c     #                   fourier (ndata,rdata,rout)                        #
c     #                                                                     #
c     #  objective   :                                                      #
c     #                   to conduct Fourier expansion for a series of data #
c     #                                                                     #
c     #  arguments   :                                                      #
c     #                                                                     #
c     #                   ndata    :   number of data                       #
c     #                                                                     #
c     #                   rdata    :   data array of ndata elements         #
c     #                                (no missing values are allowed)      #
c     #                   rout     :   Outputs                              #
c     #                                rout(nx,nn)                          #
c     #                                nx = 1, ndata                        #
c     #                                     order in the data array         #
c     #                                nn = 1, ndata/2+2                    #
c     #                                     various components              #
c     #                                     1  ==>  mean values             #
c     #                                     2  ==>  first homonic           #
c     #                                     .....................           #
c     #                                                                     #
c     #######################################################################
c
      dimension   rdata(ndata), rout(ndata,ndata)  
c
      dimension   rsin(500,500), rcos(500,500), 
     #            aa(500), bb(500) 
c 
      pai        = 3.1415926  
c
c     1.  to initilize the output data arrays 
c 
      do 1001 nn=1,ndata 
      do 1001 nx=1,ndata 
        rout (nx,nn) = -999.0 
        rsin (nx,nn) = -999.0 
        rcos (nx,nn) = -999.0 
 1001 continue 
      do 1002 nn = 1, ndata 
        aa (nn) = -999.0 
        bb (nn) = -999.0 
 1002 continue 
c
c     2.  to judge if the number of data is even or odd 
c 
      keven = mod (ndata,2) 
      if  (keven.eq.0)  then 
        go  to  3000 
      else 
        go  to  4000 
      end  if  
c
c     3.  to conduct the Fourier expansion for even number case 
c
 3000 nt = ndata / 2 
      do 3001 nn=1,nt  
      do 3001 nx=1,ndata    
        rsin (nx,nn) = sin (2.0*pai*nn*(nx-1.0)/float(ndata))  
        rcos (nx,nn) = cos (2.0*pai*nn*(nx-1.0)/float(ndata))  
 3001 continue 
c
      a0 = 0.0 
      do 3002 nx = 1,ndata    
        a0 = a0 + rdata(nx) 
 3002 continue 
      a0 = a0 / float(ndata)   
c
      do 3004 nn = 1, nt-1    
        aa(nn) = 0.0 
        bb(nn) = 0.0 
        do 3003 nx = 1, ndata  
          aa (nn) = aa(nn) + rdata(nx)*rcos(nx,nn) 
          bb (nn) = bb(nn) + rdata(nx)*rsin(nx,nn) 
 3003   continue 
        aa (nn) = 2.0 * aa (nn) / float (ndata) 
        bb (nn) = 2.0 * bb (nn) / float (ndata)  
 3004 continue 
c
      aa (nt) = 0.0 
      do 3005 nx = 1, ndata 
        aa (nt) = aa (nt) + rdata(nx)*cos(pai*(nx-1.0)) 
 3005 continue 
      aa (nt) = aa(nt) / float(ndata) 
c
      bb (nt) = 0.0  
c
      do 3006 nx=1,ndata 
        rout (nx,1) = a0   
 3006 continue 
      do 3007 nn = 1, nt  
      do 3007 nx = 1, ndata  
        rout (nx,nn+1) = aa(nn)*rcos(nx,nn) 
     #                 + bb(nn)*rsin(nx,nn) 
 3007 continue 
      go  to  9999 
c
c     4.  to conduct the Fourier transformation for odd number series 
c 
 4000 nt = (ndata-1) / 2       
      do 4001 nn=1,nt
      do 4001 nx=1,ndata
        rsin (nx,nn) = sin (2.0*pai*nn*(nx-1.0)/float(ndata))
        rcos (nx,nn) = cos (2.0*pai*nn*(nx-1.0)/float(ndata))
 4001 continue
c
      a0 = 0.0
      do 4002 nx = 1,ndata
        a0 = a0 + rdata(nx)
 4002 continue
      a0 = a0 / float(ndata)
c
      do 4004 nn = 1, nt
        aa(nn) = 0.0
        bb(nn) = 0.0
        do 4003 nx = 1, ndata
          aa (nn) = aa(nn) + rdata(nx)*rcos(nx,nn)
          bb (nn) = bb(nn) + rdata(nx)*rsin(nx,nn)
 4003   continue
        aa (nn) = 2.0 * aa (nn) / float (ndata)
        bb (nn) = 2.0 * bb (nn) / float (ndata)
 4004 continue
c
      do 4005 nx=1,ndata
        rout (nx,1) = a0
 4005 continue
      do 4006 nn = 1, nt
      do 4006 nx = 1, ndata
        rout (nx,nn+1) = aa(nn)*rcos(nx,nn)
     #                 + bb(nn)*rsin(nx,nn)
 4006 continue
c
c      do 7777 nx=1,25 
c        ss = 0.0 
c        do 6666 nn=1,nt+1 
c          ss = ss + rout(nx,nn) 
c 6666   continue 
c        write  (6,*)  nx,rdata(nx),ss 
c 7777 continue 
c
 9999 return  
      end 
